using EVCB_OCPP.Packet.Features;
using EVCB_OCPP.Packet.Messages.SubTypes;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using System;
using System.Collections.Generic;
using System.ComponentModel.DataAnnotations;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace EVCB_OCPP.Packet.Messages.LocalAuthListManagement
{
    public class SendLocalListRequest : IRequest
    {

        public SendLocalListRequest()
        {
            Action = Actions.SendLocalList.ToString();
        }

        [JsonIgnore]
        public string Action { set; get; }

        [Required]
        public int listVersion { set; get; }

        public List<AuthorizationData> localAuthorizationList { set; get; }

        [Required]
        [JsonConverter(typeof(StringEnumConverter))]
        public UpdateType updateType { set; get; }

        public bool TransactionRelated()
        {
            return false;
        }

        public bool Validate()
        {
            return Validator.TryValidateObject(this, new ValidationContext(this), null, true);
        }
    }
}